Package: rjson
Version: 0.2.15
Date: 2014-11-02
Title: JSON for R
Author: Alex Couture-Beil <rjson_pkg@mofo.ca>
Maintainer: Alex Couture-Beil <rjson_pkg@mofo.ca>
Depends: R (>= 3.1.0)
Description: Converts R object into JSON objects and vice-versa
License: GPL-2
Repository: CRAN
Date/Publication: 2014-11-03 00:35:00
Packaged: 2014-11-02 21:27:41 UTC; alex
NeedsCompilation: yes
Built: R 3.4.1; x86_64-w64-mingw32; 2018-08-04 03:59:10 UTC; windows
Archs: x64

Package: rjson
Version: 0.2.23
Title: JSON for R
Author: Alex Couture-Beil [aut, cre]
Authors@R: person(given = "Alex", family = "Couture-Beil", role = c("aut", "cre"), email = "rjson_pkg@mofo.ca")
Maintainer: Alex Couture-Beil <rjson_pkg@mofo.ca>
Depends: R (>= 4.0.0)
Description: Converts R object into JSON objects and vice-versa.
URL: https://github.com/alexcb/rjson
License: GPL-2
Repository: CRAN
Packaged: 2024-09-16 17:34:28 UTC; root
NeedsCompilation: yes
Date/Publication: 2024-09-16 18:20:02 UTC
Built: R 4.6.0; powerpc--netbsd; 2026-07-29 08:00:23 UTC; unix

.setUp <- function() {}
.tearDown <- function() {}

test.number <- function()
{
	json <- "0"
	x <- fromJSON( json )
	checkIdentical( x, 0 )

	json <- "-0"
	x <- fromJSON( json )
	checkIdentical( x, 0 )

	json <- "15.05"
	x <- fromJSON( json )
	checkIdentical( x, 15.05 )

	json <- "-10.3"
	x <- fromJSON( json )
	checkIdentical( x, -10.3 )

	json <- "-0.3"
	x <- fromJSON( json )
	checkIdentical( x, -0.3 )

	json <- "0.3e3"
	x <- fromJSON( json )
	checkIdentical( x, 300 )

	json <- "0.2e+4"
	x <- fromJSON( json )
	checkIdentical( x, 2000 )

	json <- "0.1e-4"
	x <- fromJSON( json )
	checkIdentical( x, 0.00001 )

	# TODO check for invalid entries like 0.1e-4.5?
	failing_json <- c( ".3", "-.3", "0.1e" )
	for( bad_json in failing_json ) {
		x <- try( fromJSON( bad_json ), silent = TRUE )
		checkTrue( any( class( x ) == "try-error" ) )
	}
}

.setUp <- function() {}
.tearDown <- function() {}

test.strings <- function()
{
	json <- "\"\""
	x <- fromJSON( json )
	checkIdentical( x, "" )

	json <- "\"hello world\""
	x <- fromJSON( json )
	checkIdentical( x, "hello world" )

	json <- "\"hello\\ttab\""
	x <- fromJSON( json )
	checkIdentical( x, "hello\ttab" )

	json <- "\"hello\\\"quote\""
	x <- fromJSON( json )
	checkIdentical( x, "hello\"quote" )

	#really long string
	s <- paste( 1:100000, collapse = "-" )
	json <- paste("\"", s, "\"", sep="" )
	x <- fromJSON( json )
	checkIdentical( x, s )
}

library( rjson )
library( RUnit )


path <- system.file( "unittests", package="rjson" )
test.suite <- defineTestSuite( "json unittests", dirs = path, testFileRegexp = "^test\\..*\\.[rR]$" )
runTestSuite( test.suite, verbose = 100 )

.setUp <- function() {}
.tearDown <- function() {}

test.unicode <- function()
{
	json <- "\"\""
	x <- fromJSON( json )
	checkIdentical( x, "" )

	#test ASCII compatible utf8
	json <- "\"\\u0041\\u006c\\u0065\\u0078\\u002B\""
	x <- fromJSON( json )
	checkIdentical( x, "Alex+", paste( "got:", x ) )

	#test 2 byte utf8 unicode
	json <- "\"\\u018E\""
	x <- fromJSON( json )
	checkIdentical( x, "\u018E" )
	checkTrue( all( charToRaw( x ) == c( 0xc6, 0x8e ) ) )
	checkTrue( length( charToRaw( x ) ) == 2 )

	#test 2 byte utf8 unicode
	json <- "\"\\u018E\""
	x <- fromJSON( json )
	checkIdentical( x, "\u018E" )
	checkTrue( all( charToRaw( x ) == c( 0xc6, 0x8e ) ) )
	checkTrue( length( charToRaw( x ) ) == 2 )

	#test 3 byte utf8 unicode
	json <- "\"\\u3020\""
	x <- fromJSON( json )
	checkIdentical( x, "\u3020" )
	checkTrue( all( charToRaw( x ) == c( 0xe3, 0x80, 0xa0 ) ) )
	checkTrue( length( charToRaw( x ) ) == 3 )

	#x = newJSONParser()
	#x$addData( "\"\\u00" )
	#checkTrue( is.null( x$getObject() ) ) #should be incomplete

}

#!/usr/bin/r --slave
library( "rjson" )
library( "utils" )

#load in any extra sources
source_files <- Sys.getenv( "R_SERVER_SOURCE" )
if( source_files != "" ) {
	source_files <- strsplit( source_files, ":" )[[1]]
	for( s in source_files )
		source( s )
}

#rpc is an R object corresponding to the parsed JSON-RPC call
#returns: a JSON string with the results or error
do.rpc <- function( rpc )
{
	rpc$params <- as.list( rpc$params )

	result <- try( do.call( rpc$method, rpc$params ), silent = TRUE )

	if( class( result ) == "try-error" ) {
		#TODO JSON-RPC defines several erorrs (call not found, invalid params, and server error)
		#if a call exists but fails, I am sending a procedure not found - when really it was found 
		#but had an internal error. the data contains the actual error from R
		rpc_result <- list(
				jsonrpc = "2.0",
				error = list( code = -32601, message = "Procedure not found.", data = as.character( result ) ),
				id = rpc$id
				)
	} else {
		#RPC call suceeded
		rpc_result <- list(
				jsonrpc = "2.0",
				result = result,
				id = rpc$id
				)
	}

	#return the JSON string
	ret <- toJSON( rpc_result )
	ret <- paste( ret, "\n", sep="" )
	return( ret )
}

#requires R 2.5.0
process_stdin <- file("stdin", blocking = T, open = "rb" )
json_parser <- newJSONParser()

while( TRUE ) {

	#TODO read in data in larger chunks
	#when n > 1, readBin sometimes waits until a complete block of n chars is read - piping a flush doesn't always work when n > 1
	s <- readBin( process_stdin, what = raw(), n = 1 )

	#catch an OEF
	if( length( s ) == 0 )
		break
	s <- rawToChar( s )

	#add input to parser buffer
	json_parser$addData( s )
	#Optimization: JSON RPC objects MUST terminate with a `}' - no need to check if the object can be parsed otherwise (since it can't)
	while( s == "}" ) {
		#try to extract any JSON objects
		rpc <- try( json_parser$getObject(), silent = TRUE )
		if( class( rpc ) == "try-error" ) {
			#an error occured
			cat( '{"jsonrpc": "2.0", "error": {"code": -32700, "message": "Parse error"}, "id": null}' )
			#reset JSON parser
			json_parser <- newJSONParser()

			#clear anything on the input
			seek( process_stdin, where = 0, origin = "end" )

		} else {
			#not enough data is in the buffer to extract a complete JSON object	
			if( is.null( rpc ) )
				break

			#a valid JSON object was extracted
			ret <- do.rpc( rpc )
			cat( ret )
		}
	}
}

#must quit here - otherwise, we get dropped into an R shell
q()

.setUp <- function() {}
.tearDown <- function() {}

test.tojson <- function()
{
	x <- 15433
	j <- toJSON( x, "C" )
	checkIdentical( j, "15433" )

	x <- 15.543
	j <- toJSON( x, "C" )
	checkIdentical( j, "15.543" )

	x <- TRUE
	j <- toJSON( x, "C" )
	checkIdentical( j, "true" )

	x <- FALSE
	j <- toJSON( x, "C" )
	checkIdentical( j, "false" )

	x <- NULL
	j <- toJSON( x, "C" )
	checkIdentical( j, "null" )

	#Test strings
	x <- "hello"
	j <- toJSON( x, "C" )
	checkIdentical( j, "\"hello\"" )
	
	x <- "hel\"lo"
	j <- toJSON( x, "C" )
	checkIdentical( j, "\"hel\\\"lo\"" )

	x <- "hel\n"
	j <- toJSON( x, "C" )
	checkIdentical( j, "\"hel\\n\"" )

	x <- "\n\r\t"
	j <- toJSON( x, "C" )
	checkIdentical( j, "\"\\n\\r\\t\"" )

	x <- ""
	j <- toJSON( x, "C" )
	checkIdentical( j, "\"\"" )

	x <- "\u0041\u006c\u0065\u0078\u002B"
	j <- toJSON( x, "C" )
	checkIdentical( j, "\"Alex+\"" )

	x <- "\u018E"
	j <- toJSON( x, "C" )
	checkIdentical( j, "\"\\u018e\"" )

	x <- "\u3020"
	j <- toJSON( x, "C" )
	checkIdentical( j, "\"\\u3020\"" )

	#test arrays
	x <- c(10, 50, 30)
	j <- toJSON( x, "C" )
	checkIdentical( j, "[10,50,30]" )

	x <- list(10, 50, 30)
	j <- toJSON( x, "C" )
	checkIdentical( j, "[10,50,30]" )

	x <- list(10, 50, TRUE)
	j <- toJSON( x, "C" )
	checkIdentical( j, "[10,50,true]" )

	x <- list(10, 50, list())
	j <- toJSON( x, "C" )
	checkIdentical( j, "[10,50,[]]" )

	x <- list(10, 50, NULL)
	j <- toJSON( x, "C" )
	checkIdentical( j, "[10,50,null]" )

	x <- list()
	j <- toJSON( x, "C" )
	checkIdentical( j, "[]" )

	x <- c(T,T,F,F,T,F)
	j <- toJSON( x, "C" )
	checkIdentical( j, "[true,true,false,false,true,false]" )

	#test dicts
	x <- list(key="value")
	j <- toJSON( x, "C" )
	checkIdentical( j, "{\"key\":\"value\"}" )

	x <- c(key="value")
	j <- toJSON( x, "C" )
	checkIdentical( j, "{\"key\":\"value\"}" )

	x <- c(key=TRUE, car=FALSE)
	j <- toJSON( x, "C" )
	checkIdentical( j, "{\"key\":true,\"car\":false}" )

	x <- list(key=TRUE, car=FALSE, apple=c(10.5, 28))
	j <- toJSON( x, "C" )
	checkIdentical( j, "{\"key\":true,\"car\":false,\"apple\":[10.5,28]}" )

	x <- c(a=T,b=F)
	j <- toJSON( x, "C" )
	checkIdentical( j, "{\"a\":true,\"b\":false}" )

}

.setUp <- function() {}
.tearDown <- function() {}

test.list <- function()
{
	json <- "{}"
	x <- fromJSON( json )
	checkIdentical( x, list() )

	failing_json <- c( "{", "{a:5}", "{\"a:5}", "{\"a\":", "{\"a\":5", "{\"a\":}", "{123:false}", "{\"a\":unquoted}" )
	for( bad_json in failing_json ) {
		x <- try( fromJSON( bad_json ), silent = TRUE )
		checkTrue( any( class( x ) == "try-error" ) )
	}

	json <- "{\"a\":5}"
	x <- fromJSON( json )
	checkIdentical( x, list( a = 5 ) )

	json <- "{\"a\":5,\"b\":10}"
	x <- fromJSON( json )
	checkIdentical( x, list( a = 5, b = 10 ) )

	json <- "{\"a\":5,\"b\":10, \"clap\":[true,false,false]}"
	x <- fromJSON( json )
	correct <- list( a = 5, b = 10, clap = c(TRUE,FALSE,FALSE) )
	checkIdentical( x, correct )
	checkIdentical( x[["clap"]], correct[["clap"]] )


}

test.nestedlist <- function()
{
	json <- "[\"a\", [\"b\", \"c\"] ]"
	x <- fromJSON( json )
	correct <- list( "a", c( "b", "c" ) )
	checkIdentical( x, correct )
	checkIdentical( x[[2]], correct[[2]] )
}

test.bad.list <- function()
{
	bad_json <- "{\"a\": 123,}"
	x <- try( fromJSON( bad_json ), silent = TRUE )
	checkTrue( any( class( x ) == "try-error" ) )
}

test.unsupported.sexp <- function()
{
	x <- fromJSON('{ "key":[ { "foo":"bar" }, { "bah":"baz" }] }')
	correct <- list( key = list( list( foo = "bar" ), list( bah = "baz" ) ))
	checkIdentical( x, correct )
}

test.rejected.comma <- function()
{
	bad_json = '{ "key":[ { "foo":"bar" }, { "bah":"baz" },] }'
	x <- try( fromJSON( bad_json ), silent = TRUE )
	checkTrue( any( class( x ) == "try-error" ) )
}

.setUp <- function() {}
.tearDown <- function() {}

test.number <- function()
{
	json <- "0"
	x <- fromJSON( json )
	checkIdentical( x, 0 )

	json <- "-0"
	x <- fromJSON( json )
	checkIdentical( x, 0 )

	json <- "15.05"
	x <- fromJSON( json )
	checkIdentical( x, 15.05 )

	json <- "-10.3"
	x <- fromJSON( json )
	checkIdentical( x, -10.3 )

	json <- "-0.3"
	x <- fromJSON( json )
	checkIdentical( x, -0.3 )

	#TODO this is actually invalid JSON
	json <- "-.3"
	x <- fromJSON( json )
	checkIdentical( x, -0.3 )

	json <- "0.3e3"
	x <- fromJSON( json )
	checkIdentical( x, 300 )

	json <- "0.2e+4"
	x <- fromJSON( json )
	checkIdentical( x, 2000 )

	json <- "0.1e-4"
	x <- fromJSON( json )
	checkIdentical( x, 0.00001 )

	#TODO this should fail
	json <- "0.1e-4.5"
	x <- fromJSON( json )
	checkIdentical( x, 0 )

	#TODO this should fail
	json <- "0.1e"
	x <- fromJSON( json )
	checkIdentical( x, 0 )

}

.setUp <- function() {}
.tearDown <- function() {}

test.array <- function()
{
	json <- "[]"
	x <- fromJSON( json )
	checkIdentical( x, list() )

	failing_json <- c( "[", "[12313", "[132,", "[132,1", "[1,5,4,3,", "[1,3}" )
	for( bad_json in failing_json ) {
		x <- try( fromJSON( bad_json ), silent = TRUE )
		checkTrue( any( class( x ) == "try-error" ) )
	}

	json <- "[1]"
	x <- fromJSON( json )
	checkIdentical( x, 1 )

	json <- "[1,5,200]"
	x <- fromJSON( json )
	checkIdentical( x, c(1,5,200) )

	#multiple types are saved as a list
	json <- "[1,5,\"hello\"]"
	x <- fromJSON( json )
	checkIdentical( x, list(1,5,"hello") )

	##test arrays with arrays
	#json <- "[[[]],[]]"
	#x <- fromJSON( json )
	#checkIdentical( x, list( list(list()), list() ) )

	json <- "[null,[]]"
	x <- fromJSON( json )
	checkIdentical( x, list( NULL, list() ) )
}

.setUp <- function() {}
.tearDown <- function() {}

test.factors <- function()
{
	x <- as.factor(c("abc", "abc", "dog", "abc"))
	json <- toJSON( x )
	checkIdentical( json, "[\"abc\",\"abc\",\"dog\",\"abc\"]" )
}

#R reads in R_PROFILE first - which will start up the server.r script, which then sources in anything from R_SERVER_SOURCE
#R_SERVER_SOURCE is a colon delimited list of user source files to read in
set R_PROFILE=server.r
set R_SERVER_SOURCE=%1

set Path=.;C:\Program Files\R\R-2.9.0\bin\
r --slave --silent
